/*+
|                                               |
|     Trigger: DTULTATU_ITEMDW                  |  
|     Tabela : ITEMDW                           |
|                                               |
|     Criao:                                  |
|     11/09/2007 - Luiz Passos                  |
|                                               |
+*/

CREATE OR REPLACE TRIGGER DTULTATU_ITEMDW
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMDW FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUITDW := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTABELADW,0) <> NVL(:NEW.CDTABELADW,0)) OR
         (NVL(:OLD.CDITEMDW ,0) <> NVL(:NEW.CDITEMDW ,0)) OR
         (NVL(:OLD.NMITEMDW ,0) <> NVL(:NEW.NMITEMDW ,0)) OR
         (NVL(:OLD.IDFATODW ,0) <> NVL(:NEW.IDFATODW ,0)) OR
         (NVL(:OLD.IDTPFATODW ,0) <> NVL(:NEW.IDTPFATODW ,0)) OR
         (NVL(:OLD.DSHINTITEM ,0) <> NVL(:NEW.DSHINTITEM ,0)) OR
         (NVL(:OLD.CDAREANEGDW,0)  <> NVL(:NEW.CDAREANEGDW,0))  THEN

         :NEW.DTULTATUITDW := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ITEMDW', '', 'CDTABELADW='||:OLD.CDTABELADW||';CDITEMDW='||:OLD.CDITEMDW||';', SYSDATE);
   END IF;
END;
/


ALTER TABLE ITEMDW MODIFY DTULTATUITDW DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ITEMDW','4.11.176'); END;
/

